import {
  generateCodeDate,
  generateRandom,
} from 'src/modules/transaction/vip-code/domain/usecases/managers/helpers/generate-random.helper';
import { ILike } from 'typeorm';

export async function generateInvoiceCodeHelper(dataService) {
  const month_year = generateCodeDate();
  const char = generateRandom(1);
  const number = generateRandom(1, true);

  const invoice_code = await dataService.getOneByOptions({
    where: {
      invoice_code: ILike(`%${month_year}%`),
    },
  });

  return `INV-${month_year}${char}${number}/${invoice_code
    .count()
    .toString()
    .padStart(5, '0')}`;
}
